@ECHO OFF
IF "%1" == "" GOTO usage
SET SERVICE=%1
SET DBSERVER=%2
SET DATABASE=%3
SET START=%4
SET WHICH=%5
IF "%START%" == "" SET START=demand
IF "%START%" == "auto" goto startok
IF "%START%" == "demand" goto startok
IF "%START%" == "disabled" goto startok
ECHO.
ECHO Illegal value for 4th parameter
ECHO %START%
GOTO usage
:startok

REM //////////
SET NAVPATH=#SOURCE#
SET TARGETDIR=#TARGET#

IF "%WHICH%" == "" SET WHICH=both
IF "%WHICH%" == "both" goto whichok
IF "%WHICH%" == "servicetier" goto whichok
IF "%WHICH%" == "ws" goto whichok
ECHO.
ECHO Illegal value for 5th parameter
GOTO usage
:whichok
SET type=own
IF "%WHICH%" == "both" SET type=share
REM /////////////
SET BATPATH="%~dp0"

SET CONFIGPATH=%~dp0

IF EXIST "%NAVPATH%\Microsoft.Dynamics.Nav.Server.exe" GOTO NavPathOK
ECHO.
ECHO Unable to locate original Service directory
ECHO.
ECHO in %NAVPATH%\
ECHO.
ECHO Maybe you need to run recreateoriginalservice.bat
goto :eof
:NavPathOk
IF EXIST "%NAVPATH%%SERVICE%\Microsoft.Dynamics.Nav.Server.exe" GOTO serviceexists
C:
CD "%NAVPATH%"
REM /////////
MKDIR "%TARGETDIR%%SERVICE%"



IF ERRORLEVEL 1 GOTO nodir
XCOPY "%NAVPATH%" "%TARGETDIR%%SERVICE%" /s/e

ECHO "%BATPATH%CustomSettings.template "%TARGETDIR%%SERVICE%\CustomSettings.config" /Y 
CD\
CD %CONFIGPATH%

COPY CustomSettings.template "%TARGETDIR%%SERVICE%\CustomSettings.config" /Y 

rem %BATPATH%replacestringinfile.vbs
rem ECHO %BATPATH%replacestringinfile.vbs

SET SERVICEDIR=%TARGETDIR%%SERVICE%
ECHO "%SERVICEDIR%\customsettings.config"

%BATpath%replacestringinfile.vbs #INSTANCE# %SERVICE% "%SERVICEDIR%\customsettings.config"
IF '%DBSERVER%' == '' GOTO editconfig
%BATpath%replacestringinfile.vbs #DBSERVER# %DBSERVER% "%SERVICEDIR%\customsettings.config"
IF '%DATABASE%' == '' GOTO editconfig
%BATpath%replacestringinfile.vbs #DATABASE# %DATABASE% "%SERVICEDIR%\customsettings.config"
GOTO configdone
:editconfig
NOTEPAD %SERVICEDIR%\customsettings.config
:configdone
SC CONFIG NetTcpPortSharing start= demand
SET DEP=
if "%WHICH%" == "ws" goto onlyws
SC CREATE MicrosoftDynamicsNavServer$%SERVICE% binpath= "%SERVICEDIR%\Microsoft.Dynamics.Nav.Server.exe $%SERVICE%" DisplayName= "NAV Server %SERVICE%" type= %type% start= %START% obj= "NT Authority\NetworkService" depend= NetTcpPortSharing
SET DEP=/MicrosoftDynamicsNavServer$%SERVICE%
if "%WHICH%" == "servicetier" goto notws
:onlyws
SC CREATE MicrosoftDynamicsNavWS$%SERVICE% binpath= "%SERVICEDIR%\Microsoft.Dynamics.Nav.Server.exe $%SERVICE%" DisplayName= "NAV Server %SERVICE% WS" type= %type% start= %START% obj= "NT Authority\NetworkService" depend= HTTP/NetTcpPortSharing%DEP%
:notws
IF "%START%" == "demand" GOTO :eof
IF "%START%" == "disabled" GOTO :eof
if "%WHICH%" == "ws" goto startws
SC START MicrosoftDynamicsNavServer$%SERVICE%
if "%WHICH%" == "servicetier" goto :eof
:startws
SC START MicrosoftDynamicsNavWS$%SERVICE%
goto :eof
:serviceexists
ECHO.
ECHO Service already exists
ECHO.
GOTO :eof
:nodir
ECHO.
ECHO Could not create service directory
ECHO.
GOTO :eof
:usage
ECHO.
ECHO Usage:
ECHO.
ECHO CreateService servicetiername [databaseserver] ["databasename"] [demand^|auto^|disabled] [both^|servicetier^|ws] 
ECHO.
ECHO.
